// arbre2.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include <stdio.h>
#include <conio.h>
#include <string.h>
#include <malloc.h>
#include<stdlib.h>
#include<process.h>
#include<dos.h>
#include<ctype.h>

#define CLS  "\033[2J\33[H" 

typedef struct fichepersonne
{
	int numen;
	char sexe;
	char nom[30];
/*	char prenom[30];
	char naissance[15];
	char mort[15];
	char profession[20];
	float salaire;*/
	struct fichepersonne *pere;
	struct fichepersonne *mere;
	struct fichepersonne *enfant;
} fiche;


void clrscr(void);
void logo(void);
void menu(void);
void selection (int);
void enregistrer (fiche *);
void fin (void);
void affichagefiche(fiche *);
int ouvrir (void);
fiche * selection2 (int,fiche *,fiche *);
void nouvelle (void);
fiche * recherche (fiche *);
void modif (fiche *);
fiche *premiereficheselection(void);
void poss(fiche *);
fiche *	creerpere(fiche *);
fiche *	creermere(fiche *);
fiche *	ficheenfant(fiche *);
int numeropere (int);
int numeromere (int);
fiche * rechnum(fiche *);
fiche * rechperemere(fiche *);
fiche * cherchenum(fiche *, int);
fiche * listfich(fiche *);
void affichagefiche2(fiche *);
void inittab(int *,int);
void tritab(int *,int);
fiche *firstfiche(int);
void affboucle(fiche *);
fiche *addfiche(fiche *,int,int);
void conca(char *,char *,char *);
void freemem(fiche *);
void rechnom(fiche *);


//-------------------------------------------------------------------------
//				  M A I N
//-------------------------------------------------------------------------

void main (void)
{	
	clrscr();
	logo();
	clrscr();
	menu();
}


//-------------------------------------------------------------------------
//				  C L R S C R
//-------------------------------------------------------------------------

void clrscr (void)
{	
	int i;
	for(i=0;i!=50;i++)
		printf("\n\r");
	for(i=0;i!=50;i++)
		printf("\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b\b");
	CLS ;
}


 //-----------------------------------------------------------------------
 //                              LOGO
  //------------------------------------------------------------------------

void logo(void){
printf("\n");
printf("\n");
printf("                              PROGRAMME GENEATIQUE    \n");
printf("\n");
printf("\n");
printf("\n");
printf("\n");
printf("                 	        ~~~~~~~~~~~~~~~~~~~~  \n");
printf("                 	        (   Hello, World!  )  \n");
printf("                                ~~~~~~~~~~~~~~~~~~~~  \n");
printf("   		                         (_)         \n");
printf("   		                        c          \n");
printf("          		          =''';       \n");
printf("          		          (o=o)       \n");
printf("          		          ( V ()     \n");
printf("         		         ==m==m==c    \n");
printf("            		            )||       \n");
printf("            		            l(1       \n");
printf("             		             );     \n");
printf("\n");
printf("    		              Licence EEA 2001     \n");
printf("    		               par Fred LETELLIER     \n");
printf("\n");
printf("\n");
printf("    		         PRESSER UNE TOUCHE POUR POURSUIVRE     \n");
	getch();
}


 //-------------------------------------------------------------------------
 //                               MENU
 //---------------------------------------------------------------------------

void menu (void)
{	
	int choix,i;
	FILE *nom;
	i=0;
	while(i!=1)
	{
		printf("\n");
		printf("\n");
		printf("                              MENU PRINCIPAL    \n");
		printf("\n");
		printf("\n");
		printf("\n");
		printf("\n");

		printf("Creer une nouvelle base de donnees [0]\n\n");
		printf("Ouvrir une base de donnees deja existante [1]");
		nom=fopen("arbre.nom","r");
		if(nom==NULL)
			printf("\n(Aucune sauvegarde presente actuellement)\n -> Choix impossible");
		else
			fclose(nom);
		printf("\n\n");
		printf("Quitter le programme [2]\n\n\n");
		printf("   Que choisissez vous ? : ");
		fflush(stdin);
		scanf("%d",&choix);
		selection(choix);
		if(choix==2)
		{
			i=1;
		}
	}
}


 //-------------------------------------------------------------------------
 //                               SELECTION
 //---------------------------------------------------------------------------

void selection (int choix)
{
	int a;
	if(choix==0)
		nouvelle();

	if(choix==1)
		a=ouvrir();

	if(choix==2)
		fin();

}



//-----------------------------------------------------------------------
//       		FIN
//-----------------------------------------------------------------------

void fin (void)
{
	printf("\n\nA bientot...");
	getch();
}
   

//-----------------------------------------------------------------------
//       		NOUVELLE
//-----------------------------------------------------------------------

void nouvelle (void)
{
	fiche *tete,*pt;
	int choix,i;
	pt=premiereficheselection();
	tete=pt;

	i=0;
	affichagefiche(pt);
	poss(pt);
	fflush(stdin);
	scanf("%d",&choix);
	if(choix==6) i=1;
	pt=selection2(choix,pt,tete);


	while(i!=1)
	{
		affichagefiche(pt);
		poss(pt);
		fflush(stdin);
		scanf("%d",&choix);
		if(choix==6)
		{
			i=1;
			freemem(tete);
		}
		pt=selection2(choix,pt,tete);
	}
}


//-----------------------------------------------------------------------
//       		SAISIE DE LA PREMIERE FICHE
//-----------------------------------------------------------------------

fiche *premiereficheselection(void)
{
	fiche *p;
	p=(fiche*)malloc(sizeof(fiche));

	printf("\n\n\n\n       Creation d'une nouvelle base de donnees\n\n\n");

	printf("\n\n\nNous allons commencer par creer une premiere fiche.\nCe sera autour de cette fiche que sera cree l'arbre genealogique ascendant.\n");

	while((p->sexe)!='h'&&(p->sexe)!='H'&&(p->sexe)!='f'&&(p->sexe)!='F')
	{	
		printf("\nentrer le sexe [H/F] : ");
		fflush(stdin);
		scanf("%c",&(p->sexe));
	}
	if((p->sexe)=='h'||(p->sexe)=='H')
		(p->sexe)='H';
	else
		(p->sexe)='F';

	printf("entrer le nom : ");
	fflush(stdin);
//	fgets(p->nom,29,stdin);
	scanf("%s",p->nom);
	if(*(p->nom)==' ')
		{
			*(p->nom)='_';
		}
	p->pere=NULL;
	p->mere=NULL;
	p->enfant=p;
	if(p->sexe=='H'||p->sexe=='h')
		p->numen=1;
	else
		p->numen=2;

return p;

}



//-----------------------------------------------------------------------
//       		SELECTION 2
//-----------------------------------------------------------------------

fiche * selection2 (int choix, fiche *p,fiche *tete)
{
	fiche *pt;
	pt=tete;
	if(choix==0)
		pt=creerpere(p);

	if(choix==1)
		pt=creermere(p);

	if(choix==2)
		pt=ficheenfant(p);

	if(choix==3)
	{
		pt=p;
		modif(p);
	}

	if(choix==4)
		pt=recherche(tete);

	if(choix==5)
	{
		pt=p;
		enregistrer(tete);
	}

	return(pt);
}



//------------------------------------------------------------------------
//			MODIFICATION D'UNE FICHE
//------------------------------------------------------------------------

void modif (fiche *p)
{
	printf("\n\n\n\n       Modification de la fiche %d\n\n\n",(p->numen));

	printf("entrer le nom : ");
	fflush(stdin);
	scanf("%s",p->nom);
	if(*(p->nom)==' ')
		{
			*(p->nom)='_';
		}

}


//------------------------------------------------------------------------
//			AFFICHAGE DU CONTENU DE LA FICHE
//------------------------------------------------------------------------

void affichagefiche(fiche *p)
{
	char chainesexe[2][10]={"Homme","Femme"};
	printf("\n\n\n\n\n\n\n\n\n\n\n\n\n");
	printf("////////////////////////////////////////////\n");
	printf("//          Numero de la fiche : %d\n",(p->numen));
	printf("//   Nom    : %s\n",(p->nom));

	if(p->sexe=='H') 
	printf("//   sexe   : %s\n",chainesexe[0]);
	else
	printf("//   sexe   : %s\n",chainesexe[1]);

	printf("//   Pere   : ");
	if(p->pere==NULL)
			printf("Non\n");
	else
			printf("Oui\n");
	
	printf("//   Mere   : ");
	if(p->mere==NULL)
			printf("Non\n");
	else
			printf("Oui\n");

	printf("//   Enfant : ");
	if((p->numen)<5)
			printf("Non\n");
	else
			printf("Oui\n");
	printf("////////////////////////////////////////////\n\n\n");
}


//------------------------------------------------------------------------
//			POSSIBILITES
//------------------------------------------------------------------------
void poss(fiche *p)
{
		printf("\n        QUE VOULEZ VOUS FAIRE MAINTENANT ?");
	
		if(p->pere==NULL)
				printf("\nCreer la fiche du pere ? [0]");
		else
				printf("\nAller sur la fiche du pere ? [0]");

		if(p->mere==NULL)
				printf("\nCreer la fiche de la mere ? [1]");
		else
				printf("\nAller sur la fiche de la mere ? [1]");

		printf("\nAller sur la fiche de l'enfant ? [2]");
		if(p->numen<5)
			printf(" (IMPOSSIBLE ICI)");

		printf("\nModifier l'actuelle fiche ? [3]");
		printf("\nRechercher une fiche ? [4]");
		printf("\nSauvegarder la base de donnees ? [5]");
		printf("\nRetourner au menu principal ? [6]");
		printf("\nQue choisissez vous ? : ");
}



//------------------------------------------------------------------------
//			CREER FICHE PAPA
//------------------------------------------------------------------------

fiche *	creerpere(fiche *p)
{
	fiche *pt;
	int numen;
	if(p->pere!=NULL)
		return (p->pere);

	else
	{
		pt=(fiche*)malloc(sizeof(fiche));
		printf("\n\n\n\n       Creation de la fiche du pere\n\n\n");
		printf("entrer le nom : ");
		fflush(stdin);
		scanf("%s",pt->nom);
		if(*(pt->nom)==' ')
			{
				*(pt->nom)='_';
			}
		(pt->sexe)='H';
		pt->pere=NULL;
		pt->mere=NULL;
		pt->enfant=p;
		p->pere=pt;
		numen=p->numen;
		numen=numeropere(numen);
		pt->numen=numen;
		return pt;
	}
}



//------------------------------------------------------------------------
//			CREER FICHE MAMAN
//------------------------------------------------------------------------

fiche *	creermere(fiche *p)
{
	fiche *pt;
	int numen;
	if(p->mere!=NULL)
		return (p->mere);

	else
	{
		pt=(fiche*)malloc(sizeof(fiche));
		printf("\n\n\n\n       Creation de la fiche de la mere\n\n\n");
		printf("entrer le nom : ");
		fflush(stdin);
		scanf("%s",pt->nom);
		if(*(pt->nom)==' ')
			{
				*(pt->nom)='_';
			}
		(pt->sexe)='F';
		pt->pere=NULL;
		pt->mere=NULL;
		pt->enfant=p;
		p->mere=pt;
		numen=p->numen;
		numen=numeromere(numen);
		pt->numen=numen;
		return pt;
	}
}


//------------------------------------------------------------------------
//			VOIR FICHE ENFANT
//------------------------------------------------------------------------

fiche *	ficheenfant(fiche *p)
{
	fiche *pt;

	if(p->numen<5)
		return (p);

	else
	{
		pt=(p->enfant);
		return pt;
	}
}



//------------------------------------------------------------------------
//			RECHERCHER FICHE
//------------------------------------------------------------------------

fiche * recherche (fiche *tete)
{
	fiche *pt;
	int choix;
	pt=tete;
	printf("\n\n\n\n       Module de recheche\n\n\n");
	printf("Choisissez votre mode de recherche : \n\n");
	printf("  - Recherche d'un individu par son numero [0]\n\n");
	printf("  - Recherche du pere ou de la mere d'un individu [1]\n\n");
	printf("  - Recherche de la liste des ascendant hommes ou femmes d'un individu, sur un nombre de generations donne [2]\n\n");
	printf("  - Recherche d'un individu par son nom [3]\n\n");

	printf("Votre choix : ");
	fflush(stdin);
	scanf("%d",&choix);
	if(choix==0)
		pt=rechnum(tete);
	if(choix==1)
		pt=rechperemere(tete);
	if(choix==2)
		pt=listfich(tete);
	if(choix==3)
		rechnom(tete);

	return pt;
}






//------------------------------------------------------------------------
//			NUMERO DE LA FICHE DU PERE
//------------------------------------------------------------------------

int numeropere (int numero)
{
	int numero2,i,puissance,j;
	numero2=numero;
	for(i=0;numero!=0;i++)
	{
		numero=(int)(numero/10);
	}
	puissance=10;
	for(j=0;j!=(i-1);j++)
	puissance=puissance*10;

	numero=1*puissance;
	numero2=numero2+numero;
	return numero2;
}

//------------------------------------------------------------------------
//			NUMERO DE LA FICHE DE LA MAMAN
//------------------------------------------------------------------------

int numeromere (int numero)
{
	int numero2,i,puissance,j;
	numero2=numero;
	for(i=0;numero!=0;i++)
	{
		numero=(int)(numero/10);
	}
	puissance=10;
	for(j=0;j!=(i-1);j++)
	puissance=puissance*10;

	numero=2*puissance;
	numero2=numero2+numero;
	return numero2;
}


//------------------------------------------------------------------------
//			RECHERCHE D'UNE FICHE GRACE A SON NUMERO
//------------------------------------------------------------------------

fiche * rechnum(fiche *tete)
{
	fiche *pt;
	int nb,a,b,c;
	printf("\nVeuillez indiquer le numero de la fiche a laquelle vous souhaitez acceder : ");
	fflush(stdin);
	scanf("%d",&nb);
	pt=tete;

	if(pt->numen==nb)
		return tete;

	if(nb<11&&nb!=(pt->numen))
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}

	a=nb;
	b=nb;
	b=(int)(b/10);
	b=b*10;
	c=a-b;
	if(pt->numen!=c)
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}



	a=nb;
	b=nb;
	a=(int)(a/10);
	b=(int)(b/10);
	for(;nb!=pt->numen;)
	{
		b=(int)(b/10);
		b=b*10;
		c=a-b;
		a=(int)(a/10);
		b=(int)(b/10);
		if(c!=1&&c!=2)
			break;
		if(c==1)
			pt=pt->pere;
		if(c==2)
			pt=pt->mere;
		if(pt==NULL)
			break;
	}

	if(pt==NULL)
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}

	if(pt->numen==nb)
		return pt;

	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}
}


//------------------------------------------------------------------------
//			RECHERCHE DU PERE OU DE LA MERE D'UNE FICHE
//------------------------------------------------------------------------

fiche * rechperemere(fiche *tete)
{
	fiche *pt;
	int nbfiche,choix;
	printf("\nVeuillez donner le numero de la fiche dont vous souhaitez vous voir le pere ou la mere : ");
	fflush(stdin);
	scanf("%d",&nbfiche);
	printf("Voulez vous voir la fiche du pere ou de la mere ? ('1' pour le pere et '2' pour la mere) : ");
	fflush(stdin);
	scanf("%d",&choix);
	pt=cherchenum(tete,nbfiche);

	if(choix==1)
		pt=pt->pere;
	if(choix==2)
		pt=pt->mere;
	if(choix!=1&&choix!=2)
		return tete;
	if(pt==NULL)
	{
		printf("La fiche que vous souhaitez afficher n'existe pas");
		pt=tete;
	}

	return pt;
}


//------------------------------------------------------------------------
//			RECHERCHE D'UNE FICHE GRACE A SON NUMERO
//------------------------------------------------------------------------

fiche * cherchenum(fiche *tete, int nb)
{
	fiche *pt;
	int a,b,c;
	pt=tete;

	if(pt->numen==nb)
		return tete;

	if(nb<11&&nb!=(pt->numen))
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}

	a=nb;
	b=nb;
	b=(int)(b/10);
	b=b*10;
	c=a-b;
	if(pt->numen!=c)
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}



	a=nb;
	b=nb;
	a=(int)(a/10);
	b=(int)(b/10);
	for(;nb!=pt->numen;)
	{
		b=(int)(b/10);
		b=b*10;
		c=a-b;
		a=(int)(a/10);
		b=(int)(b/10);
		if(c!=1&&c!=2)
			break;
		if(c==1)
			pt=pt->pere;
		if(c==2)
			pt=pt->mere;
		if(pt==NULL)
			break;
	}

	if(pt==NULL)
	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}

	if(pt->numen==nb)
		return pt;

	{
		printf("\nCette fiche n'existe pas");
		printf("\nNous vous renvoyons a la racine de l'arbre");
		return tete;
	}
}


//------------------------------------------------------------------------
//			LISTE DES PARENTS D'UNE PERSONNE
//------------------------------------------------------------------------

fiche * listfich(fiche *tete)
{
	fiche *pt,*p;
	int nbfiche,choix,nbgen,i,a;
	printf("\nVeuillez donner le numero de la fiche qui servira de racine : ");
	fflush(stdin);
	scanf("%d",&nbfiche);
	printf("Voulez vous voir les fiches du pere ou de la mere ? ('1' pour le pere et '2' pour la mere) : ");
	fflush(stdin);
	scanf("%d",&choix);
	printf("Combien de generations voulez vous voir ? : ");
	fflush(stdin);
	scanf("%d",&nbgen);

	pt=cherchenum(tete,nbfiche);
	p=pt;
	affichagefiche2(p);

	if(choix==1)
	{
		for(i=0;i!=nbgen;i++)
		{
			p=p->pere;
			if(p==NULL)
			{
				break;
			}
			affichagefiche2(p);
			a=i%2;
			if(a==0)
			{
				printf("\n(Pressez une touche pour poursuivre)");
				getch();
			}
		}
	}

	if(choix==2)
	{
		for(i=0;i!=nbgen;i++)
		{
			p=p->mere;
			if(p==NULL)
			{
				break;
			}
			affichagefiche2(p);
			a=i%2;
			if(a==0)
			{
				printf("\n(Pressez une touche pour poursuivre)");
				getch();
			}
		}
	}

	printf("\nNous vous renvoyons sur la fiche racine que vous avez choisi");
	return pt;

}



//------------------------------------------------------------------------
//			AFFICHAGE SIMPLIFIE DU CONTENU DE LA FICHE
//------------------------------------------------------------------------

void affichagefiche2(fiche *p)
{
	char chainesexe[2][10]={"Homme","Femme"};
	printf("\n");
	printf("////////////////////////////////////////////\n");
	printf("//          Numero de la fiche : %d\n",(p->numen));
	printf("//   Nom    : %s\n",(p->nom));

	if(p->sexe=='H') 
	printf("//   sexe   : %s\n",chainesexe[0]);
	else
	printf("//   sexe   : %s\n",chainesexe[1]);

	printf("////////////////////////////////////////////\n");
}




//------------------------------------------------------------------------
//			ENREGISTREMENT DE L'ARBRE BINAIRE
//------------------------------------------------------------------------

void enregistrer (fiche *p)
{
	fiche *pere,*mere,*pt;
	FILE *f,*nom,*d;
	char nomfichier[30],str1[]={".sav"},nomfichier2[50],str2[]={".tab"};
	int i=0,n,a,m;
	int j=0,x,c;
	int *tab;
    printf("Entrez le nom du fichier a creer : ");
	fflush(stdin);
	fgets(nomfichier,30,stdin);
	printf("\nVeuillez noter le nom de votre base de donnees : %s (utile pour recuperer vos donnees)",nomfichier);

   	nom=fopen("arbre.nom","w");
	fprintf(nom,"%s\n",nomfichier);
	fclose(nom);
	conca(nomfichier,str2,nomfichier2);
	d=fopen(nomfichier2,"w");
	x=1;
	tab=(int *) malloc (sizeof(int)*100*x);
	if(tab==NULL)
	{
		printf("\nAllocation de memoire impossible");
	}
    if (!nomfichier2) 
        printf("ERREUR: Impossible d'ouvrir le fichier: %s.\n", nomfichier2);
	inittab(tab,x);
	*tab=p->numen;
	tritab(tab,x);
	pt=p;
	for(n=0;n!=1;n=1-1)
	{
		a=*tab;
		pt=cherchenum(p, a);
		fprintf(d,"%d\n",*tab);
		if(pt->pere!=NULL)
		{
			pere=pt->pere;
			*(tab+x*100-3)=pere->numen;
		}
		if(pt->mere!=NULL)
		{
			mere=pt->mere;
			*(tab+x*100-2)=mere->numen;
		}
		*tab=999999999;
		tritab(tab,x);
		if(*tab==999999999)
			break;
	}
	m=999999999;
	fprintf(d,"%d",m);
	fclose(d);

 	d=fopen(nomfichier2,"r");
	m=0;
	for(c=0;c!=100*x;c++)
	{
		fscanf(d,"%d",&m);
		if(m==999999999)
			break;
		*(tab+c)=m;
	}
	fclose(d);

	i=0;
	j=0;
	conca(nomfichier,str1,nomfichier2);
	f=fopen(nomfichier2,"w");
	if (!nomfichier2) 
        printf("ERREUR: Impossible d'ouvrir le fichier: %s.\n", nomfichier2);

	for(c=0;c!=100*x;c++)
	{
		m=*(tab+c);
		if(m==999999999)
			break;
		pt=cherchenum(p, m);
		fprintf(f,"%s\n",pt->nom);
	}	
	fclose(f);
	free(tab);
	printf("\nVotre base de donnees a bien ete sauvee.\n\n");
}



//------------------------------------------------------------------------
//			INITIALISATION DU TABLEAU
//------------------------------------------------------------------------

void inittab(int *tab,int x)
{
	int i=0;
	for(i=0;i!=100*x;i++)
		*(tab+i)=999999999;
}



//------------------------------------------------------------------------
//			TRI DU TABLEAU
//------------------------------------------------------------------------

void tritab(int *tab,int x)
{
	int i=0,j=0,c,d;
	d=0;
	for(i=0;i!=100*x;i++)
	{
		for(j=100*x-1;j>i;j--)
		{
			if(*(tab+j-1)>*(tab+j))
			{
				c=*(tab+j-1);
				*(tab+j-1)=*(tab+j);
				*(tab+j)=c;
				d=1;
			}
		}
			if(d==0) break;
			d=0;
	}
}


//-----------------------------------------------------------------------
//       		OUVRIR UNE BASE DE DONNEES
//-----------------------------------------------------------------------

int ouvrir (void)
{
	FILE *nom,*f,*g;
	fiche *tete,*d,*dd;
	char nomfichier[30],str1[]={".sav"},nomfichier2[50],str2[]={".tab"},person[50];
	int i=0,x=1,m,c,aa,ab,ac,ad,ae;
	int j=0,*tab,infini,gg;
	tab=(int *) malloc (sizeof(int)*100*x);
	if(tab==NULL)
	{
		printf("\nAllocation de memoire impossible");
	}
   	nom=fopen("arbre.nom","r");
    if (nom==NULL) 
	{
        printf("\n\nERREUR: Aucune sauvegarde presente sur le disque\n");
		printf("retour au menu");
		return 0;
	}
	fscanf(nom,"%s",nomfichier);
	fclose(nom);
    printf("\n\n\nNous allons maintenant proceder a la recuperation d'un arbre binaire\n");
    printf("Le nom du dernier arbre sauvegarde est : '%s'",nomfichier);
    printf("\nVeuillez maintenant rentrer le nom de votre base de donnees : ");

	fflush(stdin);
	fgets(nomfichier,30,stdin);

	conca(nomfichier,str2,nomfichier2);

	f=fopen(nomfichier2, "r");
    if (f==NULL) 
	{
        printf("\n\nERREUR: Impossible d'ouvrir le fichier: %s.\n", nomfichier2);
		printf("\nretour au menu");
		return 0;
	}

	inittab(tab,x);
	m=0;
	for(c=0;c!=100*x;c++)
	{
		fscanf(f,"%d",&m);
		if(m==999999999)
			break;
		*(tab+c)=m;
	}
	fclose(f);

	m=*tab;
	tete=firstfiche(m);

	infini=1;
	for(infini=1;infini!=0;infini++)
	{
		m=*(tab+infini);
		if(m==999999999||m<=0)
			break;

		aa=m;
		ab=m;
		ac=0;
		while(ab>10)
		{
			ab=(int)(ab/10);
			ac++;
			ae=ab;
		}
		while(ac!=0)
		{
			ab=ab*10;
			ac--;
		}
		ad=aa-ab;
		d=cherchenum(tete, ad);
		dd=addfiche(d,m,ae);
		
	}

	i=0;
	j=0;
	conca(nomfichier,str1,nomfichier2);
	g=fopen(nomfichier2, "r");
	m=0;
	for(gg=0;gg!=infini;gg++)
	{
		fscanf(g,"%s",person);
		aa=*(tab+gg);
		d=cherchenum(tete, aa);

		ab=0;
		while (person[ab]!=0)
		{	
			d->nom[ab]=person[ab];
			ab++;
		}
		d->nom[ab]='\0';
	}
	fclose(g);

	free(tab);

	affboucle(tete);
	return 0;
}




//-----------------------------------------------------------------------
//       		CREATION LA PREMIERE FICHE
//-----------------------------------------------------------------------

fiche *firstfiche(int m)
{
	fiche *p;
	p=(fiche*)malloc(sizeof(fiche));

	if(m==1)
	{
		(p->sexe)='H';
	}

	if(m==2)
	{
		(p->sexe)='F';
	}


	p->pere=NULL;
	p->mere=NULL;
	p->enfant=p;
	p->numen=m;

	return p;

}


//-----------------------------------------------------------------------
//       		NOUVELLE FICHE RECUPERATION
//-----------------------------------------------------------------------

void affboucle(fiche *tete)
{
	fiche *pt;
	int choix,i;
	pt=tete;

	for(i=0;i!=1;)
	{
		affichagefiche(pt);
		poss(pt);
		fflush(stdin);
		scanf("%d",&choix);
		pt=selection2(choix,pt,tete);
		if(choix==6)
		{
			i=1;
			freemem(tete);
		}
	}
}


//-----------------------------------------------------------------------
//       		CREATION DES FICHES
//-----------------------------------------------------------------------

fiche *addfiche(fiche *pt,int m, int ae)
{
	fiche *p;
	p=(fiche*)malloc(sizeof(fiche));

	if(ae==1)
	{
		(p->sexe)='H';
		(pt->pere)=p;
	}

	if(ae==2)
	{
		(p->sexe)='F';
		(pt->mere)=p;
	}


	p->pere=NULL;
	p->mere=NULL;
	p->enfant=pt;
	p->numen=m;

return p;

}


//-----------------------------------------------------------------------
//       		ASSOCIATION DE MOTS
//-----------------------------------------------------------------------

void conca(char *nomfichier,char *str2, char *nomfichier2)
{
	int i=0,j=0;
	while (*(nomfichier+i)!=10)
	{	
		*(nomfichier2+i)=*(nomfichier+i);
		i++;
	}
	*(nomfichier2+i)='\0';
	i=0;
	while (*(nomfichier2+i)!=0)
	{	
		i++;
	}	
		while (*(str2+j)!=0)
	{
			*(nomfichier2+i)=*(str2+j);	
		i++;
		j++;
	}
	*(nomfichier2+i)='\0';
}


//-----------------------------------------------------------------------
//       		NETTOYAGE DE LA MEMOIRE
//-----------------------------------------------------------------------

void freemem(fiche *tete)
{
	fiche *pere,*mere,*pt,*p;
	int x=1,*tab1,n,a;
	int *tab2;

	p=tete;
	tab1=(int *) malloc (sizeof(int)*100*x);
	tab2=(int *) malloc (sizeof(int)*100*x);
	if(tab1==NULL||tab2==NULL)
	{
		printf("\nAllocation de memoire impossible");
	}
	inittab(tab1,x);
	inittab(tab2,x);
	*tab1=p->numen;
	tritab(tab1,x);
	pt=tete;
	for(n=0;n!=(100*x);n++)
	{
		a=*tab1;
		pt=cherchenum(p, a);
		if(pt->pere!=NULL)
		{
			pere=pt->pere;
			*(tab1+x*100-3)=pere->numen;
		}
		if(pt->mere!=NULL)
		{
			mere=pt->mere;
			*(tab1+x*100-2)=mere->numen;
		}
		*(tab2+n)=*tab1;
		*tab1=999999999;
		tritab(tab1,x);
		if(*tab1==999999999)
			break;
	}
	free(tab1);

	while(n!=-1)
	{
		a=*(tab2+n);
		pt=cherchenum(tete, a);
		free(pt);
		n--;
	}


	free(tab2);
}


//-----------------------------------------------------------------------
//       		RECHERCHE A PARTIR DU NOM
//-----------------------------------------------------------------------

void rechnom(fiche *tete)
{
	fiche *pere,*mere,*pt,*p,*point;
	int x=1,*tab1,n,a,nbreponse=0,dif;
	int *tab2,i,nb,j,k,m;
	char nom[30],*d,copnom[30],*e;

	p=tete;
	tab1=(int *) malloc (sizeof(int)*100*x);
	tab2=(int *) malloc (sizeof(int)*100*x);
	if(tab1==NULL||tab2==NULL)
	{
		printf("\nAllocation de memoire impossible");
	}
	inittab(tab1,x);
	inittab(tab2,x);
	*tab1=p->numen;
	tritab(tab1,x);
	pt=tete;
	for(n=0;n!=(100*x);n++)
	{
		a=*tab1;
		pt=cherchenum(p, a);
		if(pt->pere!=NULL)
		{
			pere=pt->pere;
			*(tab1+x*100-3)=pere->numen;
		}
		if(pt->mere!=NULL)
		{
			mere=pt->mere;
			*(tab1+x*100-2)=mere->numen;
		}
		*(tab2+n)=*tab1;
		*tab1=999999999;
		tritab(tab1,x);
		if(*tab1==999999999)
			break;
	}
	free(tab1);

	printf("\nVeuillez indiquer le nom que vous chercher : ");
	fflush(stdin);
	scanf("%s",nom);

	dif='a'-'A';
	d=&nom[0];
	for(i=0;*(d+i)!='\0';i++)
	{
		if(*(d+i)>='a'&&*(d+i)<='z')
		{
			*(d+i)=*(d+i)-dif;
		}
	}
	

	for(i=0;*(tab2+i)!=999999999;i++)
	{
		nb=*(tab2+i);
		point=cherchenum(tete, nb);

		for(j=0;*(point->nom+j)!='\0';j++)
		{
			copnom[j]=*(point->nom+j);
		}
		copnom[j]='\0';
	
		e=&copnom[0];
		for(k=0;*(e+k)!='\0';k++)
		{
			if(*(e+k)>='a'&&*(e+k)<='z')
			{
				*(e+k)=*(e+k)-dif;
			}
		}

		for(m=0;nom[m]!='\0'||copnom[m]!='\0';m++)
		{
			if(*(nom+m)!=*(copnom+m))
			{
			*(tab2+i)=999999999;
			break;
			}
		}

	}
	tritab(tab2,x);
	for(nbreponse=0;*(tab2+nbreponse)!=999999999;nbreponse++);

	if(nbreponse<2)
	{
		printf("\n Il y a %d reponse",nbreponse);
	}
	else
		printf("\n Il y a %d reponses",nbreponse);

	for(nbreponse=0;*(tab2+nbreponse)!=999999999;nbreponse++)
	{
		pt=cherchenum(tete, *(tab2+nbreponse));
		affichagefiche2(pt);
		a=nbreponse%2;
		if(a==0)
		{
			printf("\n(Pressez une touche pour poursuivre)");
			getch();
		}
	}

	free(tab2);
	printf("\nretour a la racine de l'abre");
}

